include('shared.lua')

local SmokeOn = CreateClientConVar( 'fireworks_smoke', '1', true, false)
local FlameGlow = CreateClientConVar( 'fireworks_flame', '1', true, false)

function ENT:Initialize()

	self.Emitter = ParticleEmitter( self:GetPos(), false ) -- I have a feeling that using this position may be bad if the firework moves. Maybe taking it out of the players PVS?
	self.NextPuff = CurTime()

	MX, MN = self:GetRenderBounds()

	self:SetRenderBounds( MN + Vector( 0, 0, 512 ), MX )
	
end

local Mat = Material( 'sprites/gmdm_pickups/light' )

-- Technically because I'm doing this in Draw, some players may see less particles if they have lower FPS. But this might be a good thing, because it won't drown them any more.
function ENT:Draw()

	self:DrawModel()

	if FrameTime() == 0 || !self.Emitter || ( self.NextPuff > CurTime() ) then return end // Don't do the effects if the player is paused (this would be bad)
	
	local Pos = self:GetPos() + self:GetUp()*19
	local FuseLevel = self:GetDTInt( 0 ) || 0
	local FlameColor = self:GetDTVector( 0 ) || Vector( 255, 165, 0 )
	
	local Force = math.Rand( 100, 250 )
	
	if FuseLevel > 1 && FlameGlow:GetBool() then
	
		local Particle	= self.Emitter:Add( 'sprites/gmdm_pickups/light', Pos + VectorRand() )
		
		if Particle then

			Particle:SetVelocity( self:GetUp()*Force + VectorRand()*10 )
			Particle:SetDieTime( math.Rand( 0.75, 1.25 ) )
			
			Particle:SetColor( FlameColor.x, FlameColor.y, FlameColor.z )
			Particle:SetStartAlpha( math.Rand( 100, 255 ) )
			
			
			Particle:SetStartSize( math.Rand( 5, 50 ) )
			Particle:SetEndSize( math.Rand( 0.1, 0.5 ) )
			
			Particle:SetGravity( Vector( 0, 0, -400 ) )
			
			Particle:SetCollide( true )
			Particle:SetBounce( 1 )
			
		end
		
		-- Draw a nice flashing sprite.
		
		local SizeSprite = math.cos( CurTime()*10 )*256
		
		render.SetMaterial( Mat )
		render.DrawSprite( Pos, SizeSprite, SizeSprite, Color(FlameColor.x, FlameColor.y, FlameColor.z) )

	
	end
	
	if FuseLevel > 0 && SmokeOn:GetBool() then
	
		local Smoke	= self.Emitter:Add( 'particles/smokey', Pos + VectorRand() )
		
		if Smoke then

			Smoke:SetVelocity( self:GetUp()*(Force/2) + VectorRand()*10 )
			Smoke:SetDieTime( math.Rand( 1, 3 ) )
			
			local RandCol = math.Rand( 35, 255 )
			
			Smoke:SetColor( RandCol, RandCol, RandCol )
			Smoke:SetStartAlpha( math.Rand( 35, 100 ) )
			Smoke:SetEndAlpha( 0 )
			
			Smoke:SetStartSize( math.Rand( 0.5, 5 ) )
			Smoke:SetEndSize( math.Rand( 10, 20 ) )
			
			Smoke:SetRoll( true )
			Smoke:SetRollDelta( math.Rand( -2, 2 ) )
			
			Smoke:SetGravity( Vector( 0, 0, 100 ) )

		end
	
	end

	self.NextPuff = CurTime()+math.random(0.3, 0.5)
	
end

function ENT:OnRemove()

	if !self.Emitter then return end
	
	self.Emitter:Finish()

end